package com.example.usuario.tesis;
import android.app.Service;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.Intent;
import android.os.IBinder;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Set;
import java.util.UUID;

public class blue extends Service {

    BluetoothDevice btdis;
    BluetoothAdapter btadap;
    BluetoothSocket btench;
    InputStream entcad;
    OutputStream salcad;
    int bufpos;
    byte[] lbuf;
    volatile boolean detbt;
    private String salida;
    public blue() {
    }
    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        new Thread(new Runnable() {
            public void run() {
                encobt();
                try {
                    abrbt();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                try {
                    Thread.sleep(3000);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                entdat();
            }
        }).start();
        return START_REDELIVER_INTENT;
    }
    @Override
    public IBinder onBind(Intent intent) {
        // TODO: Return the communication channel to the service.
       // throw new UnsupportedOperationException("Not yet implemented");
        return null;
    }
    void encobt()
    {
        btadap = BluetoothAdapter.getDefaultAdapter();
        if(btadap == null)
        {
            //  txtest.setText("bluetooth no disponible");
        }

        if(!btadap.isEnabled())
        {
            Intent enableBluetooth = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
            // startActivityForResult(enableBluetooth,REQUEST_ENABLE_BT);
        }

        Set<BluetoothDevice> pairedDevices = btadap.getBondedDevices();
        if(pairedDevices.size() > 0)
        {
            for(BluetoothDevice device : pairedDevices)
            {
                if(device.getName().equals("HC-06"))
                {
                    btdis = device;
                    break;
                }
            }
        }
        //txtest.setText("Bluetooth encontrado");
    }
    void abrbt() throws IOException
    {
        UUID uuid = UUID.fromString("00001101-0000-1000-8000-00805f9b34fb"); //Standard SerialPortService ID
        btench = btdis.createRfcommSocketToServiceRecord(uuid);
        //try {
        btench.connect();
        // }
        // catch (IOException ex)
        // {
        //    txtmen.setText("Bluetooth no abierto");
        // }
        salcad = btench.getOutputStream();
        entcad = btench.getInputStream();
        //txtest.setText("Conectado");
        // b="conectado";
    }
    void entdat()
    {
        final byte delimiter = 10;
        detbt = false;
        bufpos = 0;
        salida="";
        lbuf = new byte[1024];
        int x=1;
        while(x==1)
        {
            try
            {
                int bytesAvailable = entcad.available();
                if(bytesAvailable > 0)
                {
                    byte[] packetBytes = new byte[bytesAvailable];
                    entcad.read(packetBytes);
                    for(int i=0;i<bytesAvailable;i++)
                    {
                        byte b = packetBytes[i];
                        if(b == delimiter)
                        {
                            byte[] encodedBytes = new byte[bufpos];
                            System.arraycopy(lbuf,0, encodedBytes,0, encodedBytes.length);
                            final String dato = new String(encodedBytes, "US-ASCII");
                            salida=dato;
                            bufpos = 0;
                            Intent broadcastIntent = new Intent();
                            broadcastIntent.setAction(desplegar.bcsa);
                            broadcastIntent.putExtra("Data", "1");
                            sendBroadcast(broadcastIntent);
                            try {
                                Thread.sleep(2000);
                            } catch (InterruptedException e) {
                                e.printStackTrace();
                            }
                        }
                        else
                        {
                            lbuf[bufpos++] = b;
                        }
                    }
                }
            }
            catch (IOException ex)
            {
                detbt = true;
            }
        }
    }
}
